import { jsx as ___EmotionJSX } from "@emotion/core";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import { Transition } from 'react-transition-group';
import { ANIMATION } from '../../../constants';

var getStyleForTransitionState = function getStyleForTransitionState(transitionState) {
  switch (transitionState) {
    case 'entering':
      return {
        opacity: '0',
        maxHeight: '0'
      };

    case 'entered':
      return {
        opacity: '1',
        maxHeight: '50px',
        transitionDuration: ANIMATION.defaultTiming,
        transitionProperty: 'max-height, opacity',
        transitionTimingFunction: 'ease-out'
      };

    case 'exiting':
      return {
        opacity: '0',
        maxHeight: '0',
        transitionDuration: ANIMATION.defaultTiming,
        transitionProperty: 'max-height, opacity',
        transitionTimingFunction: 'ease-in'
      };

    case 'exited':
      return {
        opacity: '0',
        maxHeight: '0'
      };

    default:
      return {};
  }
};

var HelperTransition = function HelperTransition(_ref) {
  var child = _ref.children,
      props = _objectWithoutProperties(_ref, ["children"]);

  return ___EmotionJSX(Transition, _extends({
    timeout: 350
  }, props), function (transitionState) {
    return React.cloneElement(child, {
      style: getStyleForTransitionState(transitionState)
    });
  });
};

export default HelperTransition;