import { jsx as ___EmotionJSX } from "@emotion/core";
import React from 'react';
import renderer from 'react-test-renderer';
import { mount } from 'enzyme';
import { ErrorItem } from './style';
import Field from './index';
describe('<Field />', function () {
  describe('UI Snapshot', function () {
    it('renders with label prop', function () {
      var labelText = 'Test Label';
      var component = renderer.create(___EmotionJSX(Field, {
        label: labelText
      }, ___EmotionJSX(Field.Input, null)));
      var tree = component.toJSON();
      expect(tree).toMatchSnapshot();
    });
    it('renders with label and labelFor', function () {
      var labelText = 'Test Label';
      var labelFor = 'for-input-id';
      var component = renderer.create(___EmotionJSX(Field, {
        label: labelText,
        labelFor: labelFor
      }, ___EmotionJSX(Field.Input, null)));
      var tree = component.toJSON();
      expect(tree).toMatchSnapshot();
    });
  });
  describe('when provided an error object show the message', function () {
    it('renders the error messages', function () {
      var errors = {
        maxLength: 'Maximum 6 characteres'
      };
      var wrapper = mount(___EmotionJSX(Field, {
        errors: errors
      }, ___EmotionJSX(Field.Input, null)));
      var li = wrapper.find(ErrorItem);
      expect(li).toHaveLength(1);
      expect(li.text().match(errors.maxLength)).toBeTruthy();
    });
  });
});